(define-module (bible-tools latex-export)
  #:use-module (bible-tools)
  #:use-module (srfi srfi-1)
  #:use-module (srfi srfi-26)
  #:export (as-latex))

(define (verse-to-latex v)
  (define (latex-first c sec b sec-end)
    (if (string=? (c v) "1") (string-append sec (b v) sec-end) ""))
  (let* ((book (latex-first chapter "\\section{" book "}\n"))
         (chapter
          (latex-first verse "\\textbf{\\large{" chapter "}}\n")))
    (string-append chapter
                   "\\textsuperscript{" (verse v) "}" (text v))))

(define (as-latex text)
  (string-append "\\documentclass{article}\n\n"
                 "\\usepackage{fullpage}\n\n"
                 "\\begin{document}\n\n"
                 (string-join
                  (map verse-to-latex text)
                  "\n\n")
                 "\n\\end{document}\n"))
